stages:
  - generate
  - release

create_release:
  stage: generate
  image: ghcr.io/jitesoft/cc-gen-sharp:0.1.0
  rules:
    - if: '$CI_COMMIT_TAG'
      when: on_success
    - when: never
  script:
    - "cc-gen gen --latest > CHANGELOG.md"
  artifacts:
    paths:
      - CHANGELOG.md
    when: on_success
    expire_in: 1 hours
  tags:
    - protected

release:
  needs:
    - job: create_release
      artifacts: true
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  stage: release
  rules:
    - if: '$CI_COMMIT_TAG'
      when: on_success
    - when: never
  script:
    - echo "Creating release for ${CI_COMMIT_TAG}"
    - release-cli create --name "${CI_COMMIT_TAG}" --description "$(cat CHANGELOG.md)" --tag-name "${CI_COMMIT_TAG}"
  tags:
    - protected
